<?php
/*
Plugin Name: Variation ordering
Plugin URI: http://www.getseenonline.com.au/wp-ecommerce-variation-ordering-fix.html
Description: Provide variation ordering for the wp-ecommerce plugin.
Author: Ankur Sharma
Version: 1.00
Author URI: http://www.ankursharma.net
*/

register_activation_hook( __FILE__, 'nop_on_plugin_activate' );
add_action( 'wpsc_all_associated_variations', "wp_variation_ordering",10);

function nop_on_plugin_activate()
{
	global $wpdb;
	$wpdb->query("CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."term_sorting` ( `id` INT NOT NULL AUTO_INCREMENT PRIMARY KEY ,`name` VARCHAR( 150 ) NULL , `term_id` INT NOT NULL , `order` INT NOT NULL  )  ");
}

function wp_variation_ordering( $par )
{
	global $wpdb;

	foreach($par as $pk=>$childs )
	{
		$sorted_childs=array();
		if($childs[0]->term_id==0)
		{
			$sorted_childs[]=$childs[0];
			unset($childs[0]);
		}
		
		$term_ids=array();
		$terms=array();		
		foreach($childs as $c)
		{
			$terms[$c->term_id]=$c;
			$term_ids[]=$c->term_id;
		}
		$res=$wpdb->get_results("select * from ".$wpdb->prefix."term_sorting where term_id in (".implode(",",$term_ids).") order by `order` ");

		foreach($res as $r)
		{				
			$sorted_childs[]=$terms[$r->term_id];
			unset($terms[$r->term_id]);
		}
		foreach($terms as $r)
		{				
			$sorted_childs[]=$r;
		}
		$par[$pk]=$sorted_childs;
	}
	return $par;
}

add_action("admin_menu","vop_add_menu");

function vop_add_menu()
{
	$page1=add_submenu_page( 'edit.php?post_type=wpsc-product', __( 'Variation Order', 'wpsc' ), __( 'Variation Order', 'wpsc' ), 'administrator', 'wpsc-variation-ordering', 'wpsc_variation_ordering_fun' );
	add_action( "admin_print_scripts-$page1", 'vop_admin_print_scripts' );
	add_action("admin_head-$page1",  'vop_add_to_head', 50);
}

function vop_add_to_head()
{
?>
<script type="text/javascript">
jQuery(document).ready(function(){
jQuery( "#sortit" ).sortable({stop: function(event, ui){ jQuery("#sortit .vop_term").each(function(i,v){ jQuery(v).val(i+1); }); }});
});
</script>
<?php
}

function vop_admin_print_scripts()
{
	wp_enqueue_script('jquery-ui-draggable');
	wp_enqueue_script('jquery-ui-sortable');
}

function wpsc_variation_ordering_fun()
{
	global $wpdb;
	if(isset($_POST['vop_terms']) && count($_POST['vop_terms']))
	{
		foreach($_POST['vop_terms'] as $id=>$vl)
		{ 
			$row=$wpdb->get_row("select * from wp_term_sorting where term_id='".$id."'",ARRAY_A);
			if(isset($row['id']) && $row['id']!="")
			$wpdb->update("wp_term_sorting",array("order"=>$vl),array("term_id"=>$id));
			else
			$wpdb->insert("wp_term_sorting",array("order"=>$vl,"term_id"=>$id));
		}
	}
	$parents=get_terms('wpsc-variation',array("parent"=>0)); 
	echo '<table style="width:500px;" class="widefat"><thead><th>Name</th><th>Description</th><th>Products</th></thead>';
	foreach($parents as $p)
	{
		echo "<tr><td>
		<a href='edit.php?post_type=wpsc-product&page=wpsc-variation-ordering&parent=".$p->term_id."'>".$p->name."</a>
		</td><td>".$p->description."</td><td>".$p->count."</td></tr>";
	}
	echo "<tfoot><th>Name</th><th>Description</th><th>Products</th></tfoot></table><br><br><br>";
	
	if(isset($_GET['parent']) && $_GET['parent']!="")
	{
		$childs=get_terms('wpsc-variation',array("parent"=>$_GET['parent']));
		if(count($childs))
		{ 
			$term_ids=array();
			$terms=array();
			$sorted_childs=array();
			foreach($childs as $c)
			{
				$terms[$c->term_id]=$c;
				$term_ids[]=$c->term_id;
			}
			$res=$wpdb->get_results("select * from ".$wpdb->prefix."term_sorting where term_id in (".implode(",",$term_ids).") order by `order` ");
			
			foreach($res as $r)
			{				
				$sorted_childs[]=$terms[$r->term_id];
				unset($terms[$r->term_id]);
			}
			foreach($terms as $r)
			{				
				$sorted_childs[]=$r;
			}
				
			echo '<form method="post">
			<table style="width:300px;" class="widefat"><thead><th>Name</th><th>Description</th></thead><tbody id="sortit">';
			$i=1;
			foreach($sorted_childs as $c)
			{				
				echo "<tr><td>".$c->name."<input type='hidden' class='vop_term' name='vop_terms[".$c->term_id."]' value='".$i."' /></td><td>".$c->description."</td></tr>";
				$i++;
			}
			echo "</tbody><tfoot><th>Name</th><th>Description</th></tfoot></table>
			<input type='submit' value='Update' />
			</form>";
		}
	}
}